package cp;

public class RatingELO {
	static float calculateRatingChange(Player player, Game game) {
		Player opponent = game.getOpponent(player);
		Result.ResultType type = game.getResult().getResultType();
		float result = 0;
		//Section 8.54 says 400 is maximum difference
		//Table 8.1b. We could use the other table
		//but that would mean rounding differences compared to FIDE calculation
		if (opponent == null || !game.getResult().isPlayed())
			return 0; //This doesn't count...
		else if (opponent.getRating() == 0 || player.getRating() == 0)
			return 0; //This doesn't count either...
		float Diff = Math.abs(player.getRating() - opponent.getRating());
		if (Diff >= 392)
			result = (float)0.92;
		else if (Diff >= 375)
			result = (float)0.91;
		else if (Diff >= 358)
			result = (float)0.90;
		else if (Diff >= 345)
			result = (float)0.89;
		else if (Diff >= 329)
			result = (float)0.88;
		else if (Diff >= 316)
			result = (float)0.87;
		else if (Diff >= 303)
			result = (float)0.86;
		else if (Diff >= 291)
			result = (float)0.85;
		else if (Diff >= 279)
			result = (float)0.84;
		else if (Diff >= 268)
			result = (float)0.83;
		else if (Diff >= 257)
			result = (float)0.82;
		else if (Diff >= 246)
			result = (float)0.81;
		else if (Diff >= 236)
			result = (float)0.80;
		else if (Diff >= 226)
			result = (float)0.79;
		else if (Diff >= 216)
			result = (float)0.78;
		else if (Diff >= 207)
			result = (float)0.77;
		else if (Diff >= 198)
			result = (float)0.76;
		else if (Diff >= 189)
			result = (float)0.75;
		else if (Diff >= 180)
			result = (float)0.74;
		else if (Diff >= 171)
			result = (float)0.73;
		else if (Diff >= 163)
			result = (float)0.72;
		else if (Diff >= 154)
			result = (float)0.71;
		else if (Diff >= 146)
			result = (float)0.70;
		else if (Diff >= 138)
			result = (float)0.69;
		else if (Diff >= 130)
			result = (float)0.68;
		else if (Diff >= 122)
			result = (float)0.67;
		else if (Diff >= 114)
			result = (float)0.66;
		else if (Diff >= 107)
			result = (float)0.65;
		else if (Diff >= 99)
			result = (float)0.64;
		else if (Diff >= 92)
			result = (float)0.63;
		else if (Diff >= 84)
			result = (float)0.62;
		else if (Diff >= 77)
			result = (float)0.61;
		else if (Diff >= 69)
			result = (float)0.60;
		else if (Diff >= 62)
			result = (float)0.59;
		else if (Diff >= 54)
			result = (float)0.58;
		else if (Diff >= 47)
			result = (float)0.57;
		else if (Diff >= 40)
			result = (float)0.56;
		else if (Diff >= 33)
			result = (float)0.55;
		else if (Diff >= 26)
			result = (float)0.54;
		else if (Diff >= 18)
			result = (float)0.53;
		else if (Diff >= 11)
			result = (float)0.52;
		else if (Diff >= 4)
			result = (float)0.51;
		else if (Diff >= 0)
			result = (float)0.50;
		else
			return 0; //Should never happen!

		//Change result if we are higher rated player
		if (player.getRating() - opponent.getRating() > 0)
			result = (float)1 - result;

		//Do some arithmetics depending on result
		if (type == Result.ResultType.DRAW)
			result = result - 0.50f;
	  else if (type == Result.ResultType.WHITE_WIN && game.getBlackPlayer() == player ||
						 type == Result.ResultType.BLACK_WIN && game.getWhitePlayer() == player) {
	    result = result - 1;
		}
		//multiply by k-factor
		if (player.getK() != 0)
			result = result * player.getK();
		else
			result = result * 15; //most common value - assume this.

		return result;
	}
}
