package cp.gui;

import cp.Club;
import cp.Round;

import java.sql.SQLException;

import java.util.Collections;
import java.util.Vector;
import javax.swing.table.AbstractTableModel;

public class ClubStandingsTableModel extends AbstractTableModel {
  private String[] columnNames = {"Plac", "Klubb", "Pong"};
  private Round round;
  private ClubStandingsComparator clubStandingsComparator;
  private Vector<Club> currentClubs = new Vector<Club>();
  
  void setRound(Round round, Vector<Club> currentClubs) {
    this.round = round;
    this.currentClubs = currentClubs;
    update();
  }
  
  public String getColumnName(int col) {
    return columnNames[col].toString();
  }

  public int getRowCount() {
    if (round != null) {
      return currentClubs.size();
    }
    else {
      return 2;
    }
  }

  public int getColumnCount() {
    return columnNames.length;
  }

  public Object getValueAt(int rowIndex, int columnIndex) {
    if (round != null) {
      Collections.sort(currentClubs, clubStandingsComparator);
			Club club = currentClubs.get(rowIndex);
      if (columnIndex == 0) {
        if (rowIndex > 0) {
					Club previousClub = currentClubs.get(rowIndex-1);
          if (clubStandingsComparator.compare(club, previousClub) == 0) {
            return null;
          }
        }
        return rowIndex+1;
      }
      else if (columnIndex == 1) {
        return club.toString();
      }
      else if (columnIndex == 2) {
        return club.getScore(round);
      }
    }
    return null;
  }
  
  public boolean isCellEditable(int row, int col) {
    return false;
  }

	Round getRound() {
    return round;
  }
  
  public void update() {
    if (round != null) {
      clubStandingsComparator = new ClubStandingsComparator(round);
    }
    else {
      clubStandingsComparator = new ClubStandingsComparator(null);
    }
    fireTableDataChanged();
  }
}
