package cp.gui;

import cp.Tournament;

public class TournamentPlayerListTableModel extends PlayerListTableModel {
	private Tournament tournament;

  TournamentPlayerListTableModel() {
    super();
  }

  void setTournament(Tournament tournament) {
    this.tournament = tournament;
    update();
  }
  
	Tournament getTournament() {
    return tournament;
  }
  
  public void update() {
    if (tournament != null) {
      players = tournament.getPlayers();
    }
    else {
      players = null;
    }
    initColumnNames();
    super.update();
  }
  
  void initColumnNames() {
    columnNames.clear();
    columnNames.add("Nr");
    columnNames.add("Namn");
		if (tournament != null && tournament.getShowGroup()) {
		  columnNames.add("Grp");
		}
    columnNames.add("Klubb");
    if (tournament != null && tournament.getShowELO()) {
      columnNames.add("Rating");
    }
    this.fireTableStructureChanged();
  }

}
