package cp.tiebreak;

import cp.Game;
import cp.Player;
import cp.Round;

import java.util.Vector;

public class TiebreakMedianBuchholz extends TiebreakBuchholz implements Tiebreak {
  
  /**
   * Calculates the tiebreak score for a player up to a given round.
   * 
   */
  public double getTiebreak(Round round, Player player) {
    double min = Double.POSITIVE_INFINITY;
    double max = Double.NEGATIVE_INFINITY;
    double tiebreak = 0;
    Vector games = player.getGames();
		int maxPoints = round.getTournament().getPointsPerGame();
    for (int i = 0; i < games.size(); i++) {
      Game game = (Game)games.get(i);     
      if (game.getRoundNr() <= round.getRoundNr()) {
        double tiebreakScore = 0;
        if (!game.plays(null)) {
          Player white = game.getWhitePlayer();
          Player black = game.getBlackPlayer();
          if (white == player) {
            tiebreak += getTiebreakScore(round, black);
          }
          else if (black == player) {
            tiebreak += getTiebreakScore(round, white);
          }
        }
        else {
          tiebreakScore = maxPoints*round.getRoundNr();  // If meeting bye or wo its worth rounds/2
          tiebreak += tiebreakScore;
        }
        if (tiebreakScore > max) {
          max = tiebreakScore;
        }
        if (tiebreakScore < min) {
          min = tiebreakScore;
        }
      }
    }
    if (round.getRoundNr() > 2) {
      return tiebreak - min - max;
    }
    return tiebreak;
  }
  
  public String toString() {
    return "Median Buchholz";
  }

  public String getShortName() {
    return "M.Buch";
  }
  
}
